/******************************************************************************
 * Product: Compiere ERP & CRM Smart Business Solution                        *
 * Copyright (C) 1999-2007 ComPiere, Inc. All Rights Reserved.                *
 * This program is free software, you can redistribute it and/or modify it    *
 * under the terms version 2 of the GNU General Public License as published   *
 * by the Free Software Foundation. This program is distributed in the hope   *
 * that it will be useful, but WITHOUT ANY WARRANTY, without even the implied *
 * warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.           *
 * See the GNU General Public License for more details.                       *
 * You should have received a copy of the GNU General Public License along    *
 * with this program, if not, write to the Free Software Foundation, Inc.,    *
 * 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.                     *
 * For the text or an alternative of this public license, you may reach us    *
 * ComPiere, Inc., 3600 Bridge Parkway #102, Redwood City, CA 94065, USA      *
 * or via info@compiere.org or http://www.compiere.org/license.html           *
 *****************************************************************************/
package org.compiere.model;

/** Generated Model - DO NOT CHANGE */
import java.sql.*;
import java.math.*;
import org.compiere.framework.*;
import org.compiere.util.*;
/** Generated Model for AD_Element
 *  @author Jorg Janke (generated) 
 *  @version Release 3.0.0 - $Id: GenerateModel.java,v 1.1 2008/01/16 07:34:32 jrmt Exp $ */
public class X_AD_Element extends PO
{
/** Standard Constructor
@param ctx context
@param AD_Element_ID id
@param trxName transaction
*/
public X_AD_Element (Ctx ctx, int AD_Element_ID, String trxName)
{
super (ctx, AD_Element_ID, trxName);
/** if (AD_Element_ID == 0)
{
setAD_Element_ID (0);
setColumnName (null);
setEntityType (null);	// U
setName (null);
setPrintName (null);
}
 */
}
/** Load Constructor 
@param ctx context
@param rs result set 
@param trxName transaction
*/
public X_AD_Element (Ctx ctx, ResultSet rs, String trxName)
{
super (ctx, rs, trxName);
}
/** Serial Version No */
static final long serialVersionUID = 27466307435789L;
/** Last Updated Timestamp 2007-07-12 04:28:39.0 */
public static final long updatedMS = 1184182119000L;
/** AD_Table_ID=276 */
public static final int Table_ID=276;

/** TableName=AD_Element */
public static final String Table_Name="AD_Element";

protected static KeyNamePair Model = new KeyNamePair(276,"AD_Element");

protected BigDecimal accessLevel = new BigDecimal(4);
/** AccessLevel
@return 4 - System 
*/
protected int get_AccessLevel()
{
return accessLevel.intValue();
}
/** Load Meta Data
@param ctx context
@return PO Info
*/
protected POInfo initPO (Ctx ctx)
{
POInfo poi = POInfo.getPOInfo (ctx, Table_ID);
return poi;
}
/** Info
@return info
*/
public String toString()
{
StringBuffer sb = new StringBuffer ("X_AD_Element[").append(get_ID()).append("]");
return sb.toString();
}
/** Set System Element.
@param AD_Element_ID System Element enables the central maintenance of column description and help. */
public void setAD_Element_ID (int AD_Element_ID)
{
if (AD_Element_ID < 1) throw new IllegalArgumentException ("AD_Element_ID is mandatory.");
set_ValueNoCheck ("AD_Element_ID", new Integer(AD_Element_ID));
}
/** Get System Element.
@return System Element enables the central maintenance of column description and help. */
public int getAD_Element_ID() 
{
Integer ii = (Integer)get_Value("AD_Element_ID");
if (ii == null) return 0;
return ii.intValue();
}

/** AD_Reference_ID AD_Reference_ID=1 */
public static final int AD_REFERENCE_ID_AD_Reference_ID=1;
/** Set Reference.
@param AD_Reference_ID System Reference and Validation */
public void setAD_Reference_ID (int AD_Reference_ID)
{
if (AD_Reference_ID <= 0) set_Value ("AD_Reference_ID", null);
else
set_Value ("AD_Reference_ID", new Integer(AD_Reference_ID));
}
/** Get Reference.
@return System Reference and Validation */
public int getAD_Reference_ID() 
{
Integer ii = (Integer)get_Value("AD_Reference_ID");
if (ii == null) return 0;
return ii.intValue();
}

/** AD_Reference_Value_ID AD_Reference_ID=4 */
public static final int AD_REFERENCE_VALUE_ID_AD_Reference_ID=4;
/** Set Reference Key.
@param AD_Reference_Value_ID Required to specify, if data type is Table or List */
public void setAD_Reference_Value_ID (int AD_Reference_Value_ID)
{
if (AD_Reference_Value_ID <= 0) set_Value ("AD_Reference_Value_ID", null);
else
set_Value ("AD_Reference_Value_ID", new Integer(AD_Reference_Value_ID));
}
/** Get Reference Key.
@return Required to specify, if data type is Table or List */
public int getAD_Reference_Value_ID() 
{
Integer ii = (Integer)get_Value("AD_Reference_Value_ID");
if (ii == null) return 0;
return ii.intValue();
}
/** Set Dynamic Validation.
@param AD_Val_Rule_ID Dynamic Validation Rule */
public void setAD_Val_Rule_ID (int AD_Val_Rule_ID)
{
if (AD_Val_Rule_ID <= 0) set_Value ("AD_Val_Rule_ID", null);
else
set_Value ("AD_Val_Rule_ID", new Integer(AD_Val_Rule_ID));
}
/** Get Dynamic Validation.
@return Dynamic Validation Rule */
public int getAD_Val_Rule_ID() 
{
Integer ii = (Integer)get_Value("AD_Val_Rule_ID");
if (ii == null) return 0;
return ii.intValue();
}
/** Set DB Column Name.
@param ColumnName Name of the column in the database */
public void setColumnName (String ColumnName)
{
if (ColumnName == null) throw new IllegalArgumentException ("ColumnName is mandatory.");
if (ColumnName.length() > 40)
{
log.warning("Length > 40 - truncated");
ColumnName = ColumnName.substring(0,40);
}
set_Value ("ColumnName", ColumnName);
}
/** Get DB Column Name.
@return Name of the column in the database */
public String getColumnName() 
{
return (String)get_Value("ColumnName");
}
/** Get Record ID/ColumnName
@return ID/ColumnName pair */
public KeyNamePair getKeyNamePair() 
{
return new KeyNamePair(get_ID(), getColumnName());
}

/** DBDataType AD_Reference_ID=422 */
public static final int DBDATATYPE_AD_Reference_ID=422;
/** Binary LOB = B */
public static final String DBDATATYPE_BinaryLOB = "B";
/** Character Fixed = C */
public static final String DBDATATYPE_CharacterFixed = "C";
/** Decimal = D */
public static final String DBDATATYPE_Decimal = "D";
/** Integer = I */
public static final String DBDATATYPE_Integer = "I";
/** Character LOB = L */
public static final String DBDATATYPE_CharacterLOB = "L";
/** Number = N */
public static final String DBDATATYPE_Number = "N";
/** Timestamp = T */
public static final String DBDATATYPE_Timestamp = "T";
/** Character Variable = V */
public static final String DBDATATYPE_CharacterVariable = "V";
/** Is test a valid value.
@param test testvalue
@returns true if valid **/
public boolean isDBDataTypeValid (String test)
{
return test == null || test.equals("B") || test.equals("C") || test.equals("D") || test.equals("I") || test.equals("L") || test.equals("N") || test.equals("T") || test.equals("V");
}
/** Set Data Type.
@param DBDataType Database Data Type */
public void setDBDataType (String DBDataType)
{
if (!isDBDataTypeValid(DBDataType))
throw new IllegalArgumentException ("DBDataType Invalid value - " + DBDataType + " - Reference_ID=422 - B - C - D - I - L - N - T - V");
if (DBDataType != null && DBDataType.length() > 1)
{
log.warning("Length > 1 - truncated");
DBDataType = DBDataType.substring(0,1);
}
set_Value ("DBDataType", DBDataType);
}
/** Get Data Type.
@return Database Data Type */
public String getDBDataType() 
{
return (String)get_Value("DBDataType");
}
/** Set Description.
@param Description Optional short description of the record */
public void setDescription (String Description)
{
if (Description != null && Description.length() > 255)
{
log.warning("Length > 255 - truncated");
Description = Description.substring(0,255);
}
set_Value ("Description", Description);
}
/** Get Description.
@return Optional short description of the record */
public String getDescription() 
{
return (String)get_Value("Description");
}

/** EntityType AD_Reference_ID=389 */
public static final int ENTITYTYPE_AD_Reference_ID=389;
/** Set Entity Type.
@param EntityType Dictionary Entity Type;
 Determines ownership and synchronization */
public void setEntityType (String EntityType)
{
if (EntityType.length() > 4)
{
log.warning("Length > 4 - truncated");
EntityType = EntityType.substring(0,4);
}
set_Value ("EntityType", EntityType);
}
/** Get Entity Type.
@return Dictionary Entity Type;
 Determines ownership and synchronization */
public String getEntityType() 
{
return (String)get_Value("EntityType");
}
/** Set Length.
@param FieldLength Length of the column in the database */
public void setFieldLength (int FieldLength)
{
set_Value ("FieldLength", new Integer(FieldLength));
}
/** Get Length.
@return Length of the column in the database */
public int getFieldLength() 
{
Integer ii = (Integer)get_Value("FieldLength");
if (ii == null) return 0;
return ii.intValue();
}
/** Set Comment.
@param Help Comment, Help or Hint */
public void setHelp (String Help)
{
if (Help != null && Help.length() > 2000)
{
log.warning("Length > 2000 - truncated");
Help = Help.substring(0,2000);
}
set_Value ("Help", Help);
}
/** Get Comment.
@return Comment, Help or Hint */
public String getHelp() 
{
return (String)get_Value("Help");
}
/** Set Name.
@param Name Alphanumeric identifier of the entity */
public void setName (String Name)
{
if (Name == null) throw new IllegalArgumentException ("Name is mandatory.");
if (Name.length() > 60)
{
log.warning("Length > 60 - truncated");
Name = Name.substring(0,60);
}
set_Value ("Name", Name);
}
/** Get Name.
@return Alphanumeric identifier of the entity */
public String getName() 
{
return (String)get_Value("Name");
}
/** Set PO Description.
@param PO_Description Description in PO Screens */
public void setPO_Description (String PO_Description)
{
if (PO_Description != null && PO_Description.length() > 255)
{
log.warning("Length > 255 - truncated");
PO_Description = PO_Description.substring(0,255);
}
set_Value ("PO_Description", PO_Description);
}
/** Get PO Description.
@return Description in PO Screens */
public String getPO_Description() 
{
return (String)get_Value("PO_Description");
}
/** Set PO Help.
@param PO_Help Help for PO Screens */
public void setPO_Help (String PO_Help)
{
if (PO_Help != null && PO_Help.length() > 2000)
{
log.warning("Length > 2000 - truncated");
PO_Help = PO_Help.substring(0,2000);
}
set_Value ("PO_Help", PO_Help);
}
/** Get PO Help.
@return Help for PO Screens */
public String getPO_Help() 
{
return (String)get_Value("PO_Help");
}
/** Set PO Name.
@param PO_Name Name on PO Screens */
public void setPO_Name (String PO_Name)
{
if (PO_Name != null && PO_Name.length() > 60)
{
log.warning("Length > 60 - truncated");
PO_Name = PO_Name.substring(0,60);
}
set_Value ("PO_Name", PO_Name);
}
/** Get PO Name.
@return Name on PO Screens */
public String getPO_Name() 
{
return (String)get_Value("PO_Name");
}
/** Set PO Print name.
@param PO_PrintName Print name on PO Screens/Reports */
public void setPO_PrintName (String PO_PrintName)
{
if (PO_PrintName != null && PO_PrintName.length() > 60)
{
log.warning("Length > 60 - truncated");
PO_PrintName = PO_PrintName.substring(0,60);
}
set_Value ("PO_PrintName", PO_PrintName);
}
/** Get PO Print name.
@return Print name on PO Screens/Reports */
public String getPO_PrintName() 
{
return (String)get_Value("PO_PrintName");
}
/** Set Print Text.
@param PrintName The label text to be printed on a document or correspondence. */
public void setPrintName (String PrintName)
{
if (PrintName == null) throw new IllegalArgumentException ("PrintName is mandatory.");
if (PrintName.length() > 60)
{
log.warning("Length > 60 - truncated");
PrintName = PrintName.substring(0,60);
}
set_Value ("PrintName", PrintName);
}
/** Get Print Text.
@return The label text to be printed on a document or correspondence. */
public String getPrintName() 
{
return (String)get_Value("PrintName");
}
}
